commit 01a7bbf7959888d6b31bcbf764f48f509b1f2e31
Author: freddy77 <freddy77>
Date:   Fri May 21 14:10:31 2010 +0000

    add -i and -o options to freebcp (patch from Craig A. Berry)

diff --git a/ChangeLog b/ChangeLog
index b0cffc4..e725282 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri May 21 16:10:04 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/apps/freebcp.c src/apps/freebcp.h:
+	- add -i and -o options to freebcp (patch from Craig A. Berry)
+
 Fri May 21 16:01:47 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* vms/Makefile.am vms/descrip_mms.template vms/edit.c:
 	* vms/getpass.c:
@@ -2459,4 +2463,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3025 2010/05/21 14:02:08 freddy77 Exp $
+$Id: ChangeLog,v 1.3026 2010/05/21 14:10:31 freddy77 Exp $
diff --git a/src/apps/freebcp.c b/src/apps/freebcp.c
index c5f49db..79bd0bd 100644
--- a/src/apps/freebcp.c
+++ b/src/apps/freebcp.c
@@ -24,6 +24,10 @@
 #include <stdio.h>
 #include <ctype.h>
 
+#if HAVE_ERRNO_H
+#include <errno.h>
+#endif /* HAVE_ERRNO_H */
+
 #if HAVE_STDLIB_H
 #include <stdlib.h>
 #endif /* HAVE_STDLIB_H */
@@ -46,7 +50,7 @@
 #include <sybdb.h>
 #include "freebcp.h"
 
-static char software_version[] = "$Id: freebcp.c,v 1.52 2010/05/21 13:54:28 freddy77 Exp $";
+static char software_version[] = "$Id: freebcp.c,v 1.53 2010/05/21 14:10:31 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 void pusage(void);
@@ -192,7 +196,7 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 	 * Get the rest of the arguments 
 	 */
 	optind = 4; /* start processing options after table, direction, & filename */
-	while ((ch = getopt(argc, argv, "m:f:e:F:L:b:t:r:U:P:I:S:h:T:A:O:0:C:ncEdvV")) != -1) {
+	while ((ch = getopt(argc, argv, "m:f:e:F:L:b:t:r:U:P:i:I:S:h:T:A:o:O:0:C:ncEdvV")) != -1) {
 		switch (ch) {
 		case 'v':
 		case 'V':
@@ -263,6 +267,10 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 				pdata->pass = strdup(optarg);
 			}
 			break;
+		case 'i':
+			free(pdata->inputfile);
+			pdata->inputfile = strdup(optarg);
+			break;
 		case 'I':
 			pdata->Iflag++;
 			free(pdata->interfacesfile);
@@ -275,6 +283,10 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 		case 'h':
 			pdata->hint = strdup(optarg);
 			break;
+		case 'o':
+			free(pdata->outputfile);
+			pdata->outputfile = strdup(optarg);
+			break;
 		case 'O':
 		case '0':
 			pdata->options = strdup(optarg);
@@ -326,6 +338,27 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 		}
 	}
 
+	/*
+	 * Override stdin and/or stdout if requested.
+	 */
+
+	/* FIXME -- Since we don't implement prompting for field data types when neither -c nor -n
+	 * is specified, redirecting stdin doesn't do much yet.
+	 */
+	if (pdata->inputfile) {
+		if (freopen(pdata->inputfile, "rb", stdout) == NULL) {
+			fprintf(stderr, "%s: unable to open %s: %s\n", "freebcp", pdata->inputfile, strerror(errno));
+			exit(1);
+		}
+	}
+
+	if (pdata->outputfile) {
+		if (freopen(pdata->outputfile, "wb", stdout) == NULL) {
+			fprintf(stderr, "%s: unable to open %s: %s\n", "freebcp", pdata->outputfile, strerror(errno));
+			exit(1);
+		}
+	}
+
 	return (TRUE);
 
 }
@@ -700,6 +733,7 @@ pusage(void)
 	fprintf(stderr, "        [-U username] [-P password] [-I interfaces_file] [-S server]\n");
 	fprintf(stderr, "        [-v] [-d] [-h \"hint [,...]\" [-O \"set connection_option on|off, ...]\"\n");
 	fprintf(stderr, "        [-A packet size] [-T text or image size] [-E]\n");
+	fprintf(stderr, "        [-i input_file] [-o output_file]\n");
 	fprintf(stderr, "        \n");
 	fprintf(stderr, "example: freebcp testdb.dbo.inserttest in inserttest.txt -S mssql -U guest -P password -c\n");
 }
diff --git a/src/apps/freebcp.h b/src/apps/freebcp.h
index 53d1e26..f5c9ac8 100644
--- a/src/apps/freebcp.h
+++ b/src/apps/freebcp.h
@@ -1,4 +1,4 @@
-static char rcsid_freebcp_h[] = "$Id: freebcp.h,v 1.14 2009/07/23 18:22:00 freddy77 Exp $";
+static char rcsid_freebcp_h[] = "$Id: freebcp.h,v 1.15 2010/05/21 14:10:31 freddy77 Exp $";
 static void *no_unused_freebcp_h_warn[] = { rcsid_freebcp_h, no_unused_freebcp_h_warn };
 
 enum states
@@ -70,5 +70,7 @@ typedef struct pd
 	int Tflag;
 	int Aflag;
 	int Eflag;
+	char *inputfile;
+	char *outputfile;
 }
 BCPPARAMDATA;

